<?php

/******************************************************************************
 * iSearch - website search engine                                            *
 *                                                                            *
 * Visit the iSearch homepage at http://www.digvid.info/isearch/home.php      *
 *                                                                            *
 * Copyright (C) 2002-2003 Ian Willis. All rights reserved.                   *
 *                                                                            *
 * This script is free to use for non-commercial individual use.              *
 *                                                                            *
 * Use of this script by companies or on commercial web sites requires a      *
 * commercial license. For commercial licence details, please visit:          *
 *     http://www.digvid.info/isearch/commercial.php                          *
 *                                                                            *
 ******************************************************************************/

/* Set the following variable to True to debug the automatic spidering */
$isearch_verbose = False;

if ($isearch_verbose)
{
    echo "<P>iSearch autospider running\n";
}

if (!isset($isearch_path))
{
    if ($isearch_verbose)
    {
        echo "<P>iSearch - configuration error - \$isearch_path is not set\n";
    }
}
else
{
    /* Include configuration options */
    include ("$isearch_path/isearch_config.inc.php");

    if ($isearch_db = mysql_connect($isearch_sql_server, $isearch_sql_username, $isearch_sql_password))
    {
        if (mysql_select_db($isearch_sql_database, $isearch_db))
        {
            if ($result = mysql_query ("SELECT last_update, locked, next_id FROM $isearch_table_info"))
            {
                if ($item = mysql_fetch_object($result))
                {
                    if ((! $isearch_useLocks) || (! $item->locked) ||
                        ((time() - $item->locked_time) > $isearch_lock_timeout))
                    {
                        if ($item->next_id != -1)
                        {
                            include("$isearch_path/isearch_core.inc.php");
                            include("$isearch_path/isearch_spider.inc.php");

                            /* Open the search component */
                            if (isearch_open())
                            {
                                echo "<P>iSearch - Indexing the next file\n";

                                /* Index a single file */
                                isearch_indexAFile($isearch_verbose);

                                /* Close the search component */
                                isearch_close();
                            }
                            else if ($isearch_verbose)
                            {
                                echo "<P>iSearch - Unable to open iSearch component\n";
                            }
                        }
                        else if ($item->last_update + ($isearch_spider_hours * 3600) <= time())
                        {
                            include("$isearch_path/isearch_core.inc.php");
                            include("$isearch_path/isearch_spider.inc.php");

                            /* Open the search component */
                            if (isearch_open())
                            {
                                if ($isearch_verbose)
                                {
                                    echo "<P>iSearch - Resetting spider engine\n";
                                }

                                /* Reset the spider engine to start spidering */
                                isearch_reset();

                                /* Close the search component */
                                isearch_close();
                            }
                            else if ($isearch_verbose)
                            {
                                echo "<P>iSearch - Unable to open iSearch component\n";
                            }
                        }
                    }
                    else if ($isearch_verbose)
                    {
                        echo "<P>iSearch - unable to get lock\n";
                    }
                }
                else if ($isearch_verbose)
                {
                    echo "<P>iSearch - unable to read configuration information\n";
                }
            }
            else if ($isearch_verbose)
            {
                echo "<P>iSearch - unable to query configuration table\n";
            }
        }
        else
        {
            if ($isearch_verbose)
            {
                echo "<P>iSearch - unable to select database\n";
            }
            mysql_close($isearch_db);
        }
    }
    else if ($isearch_verbose)
    {
        echo "<P>iSearch - unable to connect to database\n";
    }
}

if ($isearch_verbose)
{
    echo "<P>iSearch autospider finished\n";
}
