<?php

/******************************************************************************
 * iSearch - website search engine                                            *
 *                                                                            *
 * Visit the iSearch homepage at http://www.digvid.info/isearch/home.php      *
 *                                                                            *
 * Copyright (C) 2002-2003 Ian Willis. All rights reserved.                   *
 *                                                                            *
 * This script is free to use for non-commercial individual use.              *
 *                                                                            *
 * Use of this script by companies or on commercial web sites requires a      *
 * commercial license. For commercial licence details, please visit:          *
 *     http://www.digvid.info/isearch/commercial.php                          *
 *                                                                            *
 ******************************************************************************/

/* Array of get/post variable names */
$isearch_get_post_vars = array(
        "action",
        "s",
        "page",
    );

$isearch_path = ".";

include("$isearch_path/isearch_core.inc.php");
include("$isearch_path/isearch_search.inc.php");

/* Open the search component */
isearch_open();

/* Check the action and set the page title accordingly */
if (isset($action))
{
    $isearch_pageTitle = $isearch_lang['results_title'];
}
else
{
    $isearch_pageTitle = $isearch_lang['search_title'];
}

echo <<<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<TITLE>$isearch_pageTitle</TITLE>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=utf-8">
<META HTTP-EQUIV="Content-Language" CONTENT="$isearch_languageCode">
<META NAME="author" CONTENT="Ian Willis">
<META NAME="copyright" CONTENT="Copyright Ian Willis. All rights reserved.">
<META NAME="robots" CONTENT="noindex">
<LINK REL=StyleSheet HREF="$isearch_path/style/$isearch_styleName.css" TYPE="text/css">
</HEAD>

<BODY>

EOF;

include("$isearch_path/isearch_header.inc.php");

echo <<<EOF

<H1 class="isearch">$isearch_pageTitle</H1>\n

EOF;

if (!isset($s))
{
    /* We do not have a search string to process */
    $s = "";
}
else
{
    /* Process the search form data */

    /* Clean the search strings */
    $s = isearch_cleanSearchString($s);

    isearch_find($s);
    if ("$page" == "")
    {
        $page = 1;
    }
    isearch_showResults($page);
}

/* Define the width (in characters) of the search string entry field */
$isearch_searchFormWidth = 40;

/* Display the search form */
include("$isearch_path/isearch_form.inc.php");

/* Close the search component */
isearch_close();

include("$isearch_path/isearch_footer.inc.php");

echo <<<EOF
</BODY>
</HTML>
EOF;

?>
