<?php

/******************************************************************************
 * iSearch - website search engine                                            *
 *                                                                            *
 * Visit the iSearch homepage at http://www.digvid.info/isearch/home.php      *
 *                                                                            *
 * Copyright (C) 2002-2003 Ian Willis. All rights reserved.                   *
 *                                                                            *
 * This script is free to use for non-commercial individual use.              *
 *                                                                            *
 * Use of this script by companies or on commercial web sites requires a      *
 * commercial license. For commercial licence details, please visit:          *
 *     http://www.digvid.info/isearch/commercial.php                          *
 *                                                                            *
 ******************************************************************************/

/******************************************************************************
 *                       START OF CONFIGURATION OPTIONS                       *
 ******************************************************************************/

/* Fill in the following as applicable for your MySQL configuration. If you
 * do not know what to put here, please contact your hosting service provider.
 */
$isearch_sql_server = "localhost";
$isearch_sql_username = "username";
$isearch_sql_password = "password";
$isearch_sql_database = "database";


/* You can change the table names that iSearch uses. This could be useful if
 * you want to include seperate indexes for different parts of your site.
 *
 * Recommended values are "search_info" and "search_urls"
 */
$isearch_table_info = "search_info";
$isearch_table_urls = "search_urls";


/* Delay between automatic respidering (in hours). This delay is used by the
 * auto_spider.inc.php script.
 *
 * Recommended value is 24 (spider each day) to 168 (spider each week)
 */
$isearch_spider_hours = 24;


/* Set whether iSearch should perform database locking when updating the
 * search index. In normal use this is not required, but if you update your
 * search index frequently, you may wish to enable this option.
 *
 * If unsure, leave this set to False.
 */
$isearch_useLocks = False;


/* Timeout (in seconds) to be used for getting the database lock. If the
 * database has been locked for more than this time, it assumed that an error
 * has ocurred and the lock can be broken. This option is only used if
 * $isearch_useLocks is set to True;
 *
 * Recommended value is 30 seconds.
 */
$isearch_lock_timeout = 30;


/* Administrator password. Set this to an empty string to disable to internal
 * administrator password protection. Otherwise set it to a password that you
 * will use for accessing the iSearch administration page.
 */
$isearch_admin_password = "";   /* Disabled */


/* PHP maximum execution time when running iSearch. If you get the error message
 * "Fatal error: Maximum execution time of xx seconds exceeded", then increase
 * this value.
 *
 * Recommended value is 60 seconds.
 */
$isearch_max_execution_time = 60;


/* If you have an unusual configuration you could use the following options as an
 * alternative. They allow parts of a URL to be replaced before it is opened.
 *
 * If your site is hosted by Lycos, you may be unable to use url file opens. Try
 * the following (ensure that path names are correct first).
 *
 *  $isearch_urlSearch  = '^http://members\.lycos\.co\.uk/username/';
 *  $isearch_urlReplace = '/data/members/free/tripod/uk/u/s/e/username/htdocs/';
 *
 * If you wish to index documents that iSearch does not (yet) support, such as
 * pdf, you could use these options to open an HTML describing the real
 * document. e.g. if you have a pdf file named "mydoc.pdf" you could store the
 * html description (or conversion) in "mydoc.pdf.html", then set as follows:
 *
 *  $isearch_urlSearch  = '\.pdf$';
 *  $isearch_urlReplace = '.pdf.html';
 *
 * Leave empty to disable this option.
 *
 * Recommended value is to leave empty
 */
$isearch_urlSearch  = '';
$isearch_urlReplace = '';


/******************************************************************************
 *                        END OF CONFIGURATION OPTIONS                        *
 ******************************************************************************/
?>
