<?php

/******************************************************************************
 * iSearch - website search engine                                            *
 *                                                                            *
 * Visit the iSearch homepage at http://www.digvid.info/isearch/home.php      *
 *                                                                            *
 * Copyright (C) 2002-2003 Ian Willis. All rights reserved.                   *
 *                                                                            *
 * This script is free to use for non-commercial individual use.              *
 *                                                                            *
 * Use of this script by companies or on commercial web sites requires a      *
 * commercial license. For commercial licence details, please visit:          *
 *     http://www.digvid.info/isearch/commercial.php                          *
 *                                                                            *
 ******************************************************************************/

/* Convert GET/POST vars */
if (is_array($isearch_get_post_vars))
{
    foreach ($isearch_get_post_vars as $var)
    {
        if (isset($_GET[$var]))
        {
            $$var = $_GET[$var];
        }
        else if (isset($_POST[$var]))
        {
            $$var = $_POST[$var];
        }
    }
}

/* Include configuration options */
include ("$isearch_path/isearch_config.inc.php");

$isearch_version = "1.8";

ini_set("max_execution_time", $isearch_max_execution_time);

/* Die function - called on a fatal error */
function isearch_die( $error = "unknown" )
{
    echo "<H1>iSearch Error:". $error."</H1>";
    isearch_log($error);
    exit;
}


/* Open the iSearch component */
function isearch_open()
{
    global $isearch_path;
    global $isearch_sql_server, $isearch_sql_username, $isearch_sql_password, $isearch_sql_database;
    global $isearch_db;

    global $isearch_nextId;
    global $isearch_adminEmail;
    global $isearch_allowedFileExtensions;
    global $isearch_allowDirectories;
    global $isearch_startUrls;
    global $isearch_allowedUrlsBeginning;
    global $isearch_allowedUrls;
    global $isearch_disallowedUrlsBeginning;
    global $isearch_disallowedUrls;
    global $isearch_maxFileSize;
    global $isearch_resultsPerPage;
    global $isearch_followFrames;
    global $isearch_googleStyleResults;
    global $isearch_targetFrame;
    global $isearch_searchLogLastEmailed;
    global $isearch_searchLogEmailDays;
    global $isearch_keepCache;
    global $isearch_langName;
    global $isearch_styleName;
    global $isearch_wizardMode;
    global $isearch_removeGetVars;
    global $isearch_wwwOption;
    global $isearch_stripDefaults;
    global $isearch_robotsDomains;
    global $isearch_robotsExcludes;

    global $isearch_table_info, $isearch_table_urls;

    global $isearch_resultColour;

    global $isearch_languageCode;
    global $isearch_lang;

    $isearch_db = mysql_connect($isearch_sql_server, $isearch_sql_username, $isearch_sql_password) or isearch_die("Unable to connect to database. Please check your iSearch MySQL server, username and password configuration options.");
    mysql_select_db($isearch_sql_database, $isearch_db) or isearch_die("Unable to select the database. Please check your iSearch MySQL database configuration option.");

    $resultInfo = mysql_query ("SELECT * FROM $isearch_table_info");
    if ($resultInfo)
    {
        $isearch_itemInfo = mysql_fetch_object($resultInfo);
        if ($isearch_itemInfo)
        {
            /* Check whether fields introduced with version 1.5 are present
             * in the table and add them if not.
             */
            if (!isset($isearch_itemInfo->search_log))
            {
                $query = "ALTER TABLE $isearch_table_info ";
                $query .= "ADD search_log LONGTEXT NOT NULL, ";
                $query .= "ADD allow_directories INT(10) DEFAULT '0' NOT NULL, ";
                $query .= "ADD max_file_size INT(10) DEFAULT '65536' NOT NULL, ";
                $query .= "ADD results_per_page INT(10) DEFAULT '10' NOT NULL, ";
                $query .= "ADD follow_frames INT(10) DEFAULT '0' NOT NULL, ";
                $query .= "ADD google_style_results INT(10) DEFAULT '0' NOT NULL, ";
                $query .= "ADD target_frame VARCHAR(255) DEFAULT '_self' NOT NULL, ";
                $query .= "ADD search_log_last_emailed INT(10) NOT NULL, ";
                $query .= "ADD search_log_email_days INT(10) DEFAULT '0' NOT NULL";

                mysql_query($query);
            }

            /* Check whether fields introduced with version 1.6 are present
             * in the table and add them if not.
             */
            if (!isset($isearch_itemInfo->lang))
            {
                $query = "ALTER TABLE $isearch_table_urls ";
                $query .= "ADD cache LONGTEXT NOT NULL, ";
                $query .= "ADD size INT(10) NOT NULL, ";
                $query .= "CHANGE words words LONGTEXT NOT NULL, ";
                $query .= "CHANGE bigwords bigwords LONGTEXT NOT NULL, ";
                $query .= "CHANGE keywords keywords LONGTEXT NOT NULL, ";
                $query .= "CHANGE description description LONGTEXT NOT NULL";

                mysql_query($query);

                $query = "ALTER TABLE $isearch_table_info ";
                $query .= "ADD keep_cache INT(10) DEFAULT '0' NOT NULL, ";
                $query .= "ADD lang VARCHAR(255) DEFAULT 'english' NOT NULL, ";
                $query .= "ADD style VARCHAR(255) DEFAULT 'classic' NOT NULL, ";
                $query .= "ADD wizard_mode INT(10) DEFAULT '0' NOT NULL, ";
                $query .= "ADD remove_get_vars TEXT NOT NULL, ";
                $query .= "CHANGE log log LONGTEXT NOT NULL, ";
                $query .= "CHANGE search_log search_log LONGTEXT NOT NULL";

                mysql_query($query);

                mysql_query ("INSERT INTO $isearch_table_info (remove_get_vars) VALUES ('PHPSESSID')");
            }

            /* Check whether fields introduced with version 1.8 are present
             * in the table and add them if not.
             */
            if (!isset($isearch_itemInfo->www_option))
            {
                $query = "ALTER TABLE $isearch_table_urls ";
                $query .= "ADD base VARCHAR(255) NOT NULL, ";
                $query .= "ADD sig VARCHAR(255) NOT NULL ";

                mysql_query($query);

                $query = "ALTER TABLE $isearch_table_info ";
                $query .= "ADD allowed_urls_beginning TEXT NOT NULL, ";
                $query .= "ADD disallowed_urls_beginning TEXT NOT NULL, ";
                $query .= "ADD www_option INT(10) DEFAULT '0' NOT NULL, ";
                $query .= "ADD strip_defaults TEXT NOT NULL, ";
                $query .= "ADD robots TEXT NOT NULL, ";
                $query .= "CHANGE start_urls start_urls LONGTEXT NOT NULL, ";
                $query .= "CHANGE allowed_urls allowed_urls LONGTEXT NOT NULL, ";
                $query .= "CHANGE disallowed_urls disallowed_urls LONGTEXT NOT NULL";

                mysql_query($query);

                $resultInfo = mysql_query ("SELECT * FROM $isearch_table_info");
            }
        }
    }

    $resultInfo = mysql_query ("SELECT * FROM $isearch_table_info");
    if ($resultInfo)
    {
        $isearch_itemInfo = mysql_fetch_object($resultInfo);
        if ($isearch_itemInfo)
        {
            $isearch_nextId = $isearch_itemInfo->next_id;
            $isearch_adminEmail = $isearch_itemInfo->admin_email;
            $isearch_allowedFileExtensions = explode(" ", $isearch_itemInfo->allowed_file_ext);
            $isearch_startUrls = explode(" ", $isearch_itemInfo->start_urls);
            $isearch_allowedUrlsBeginning = explode(" ", $isearch_itemInfo->allowed_urls_beginning);
            $isearch_allowedUrls = explode(" ", $isearch_itemInfo->allowed_urls);
            $isearch_disallowedUrlsBeginning = explode(" ", $isearch_itemInfo->disallowed_urls_beginning);
            $isearch_disallowedUrls = explode(" ", $isearch_itemInfo->disallowed_urls);

            $isearch_maxFileSize = $isearch_itemInfo->max_file_size;
            $isearch_resultsPerPage = $isearch_itemInfo->results_per_page;
            $isearch_followFrames = $isearch_itemInfo->follow_frames;
            $isearch_allowDirectories = $isearch_itemInfo->allow_directories;
            $isearch_googleStyleResults = $isearch_itemInfo->google_style_results;
            $isearch_targetFrame = $isearch_itemInfo->target_frame;
            $isearch_searchLogLastEmailed = $isearch_itemInfo->search_log_last_emailed;
            $isearch_searchLogEmailDays = $isearch_itemInfo->search_log_email_days;

            $isearch_keepCache = $isearch_itemInfo->keep_cache;
            $isearch_langName = $isearch_itemInfo->lang;
            $isearch_styleName = $isearch_itemInfo->style;
            $isearch_wizardMode = $isearch_itemInfo->wizard_mode;
            $isearch_removeGetVars = explode(" ", $isearch_itemInfo->remove_get_vars);

            $isearch_wwwOption = $isearch_itemInfo->www_option;
            $isearch_stripDefaults = explode(" ", $isearch_itemInfo->strip_defaults);

            $isearch_robotsDomains = explode(" ", ereg_replace("#.*$", "", $robots));
            $isearch_robotsExcludes = explode(" ", ereg_replace("^[^#]#", "", $robots));

            include ("$isearch_path/lang/$isearch_langName.inc.php");

            return True;
        }
    }

    return False;
}


/* Close the iSearch component */
function isearch_close()
{
    global $isearch_db;

    mysql_close($isearch_db);
}


/* Lock the search tables */
function isearch_lock()
{
    global $isearch_useLocks;
    global $isearch_table_info, $isearch_table_urls;

    if ($isearch_useLocks)
    {
        mysql_query ("LOCK TABLES $isearch_table_info WRITE");

        $resultInfo = mysql_query ("SELECT * FROM $isearch_table_info");
        if ($resultInfo)
        {
            $isearch_itemInfo = mysql_fetch_object($resultInfo);
            if ($isearch_itemInfo)
            {
                $now = time();
                if ((! $isearch_itemInfo->locked) ||
                    (($now - $isearch_itemInfo->locked_time) > $isearch_lock_timeout))
                {
                    $isearch_gotLock = True;
                    mysql_query("UPDATE $isearch_table_info SET locked_time='$now', locked='1' WHERE id='1'");
                }
            }
        }

        mysql_query ("UNLOCK TABLES");

        return $isearch_gotLock;
    }

    return True;
}


/* Unlock the search tables */
function isearch_unlock()
{
    global $isearch_useLocks;
    global $isearch_table_info;

    if ($isearch_useLocks)
    {
        mysql_query("UPDATE $isearch_table_info SET locked='0' WHERE id='1'");
    }
}


?>
