<?php

/******************************************************************************
 * iSearch - website search engine                                            *
 *                                                                            *
 * Visit the iSearch homepage at http://www.digvid.info/isearch/home.php      *
 *                                                                            *
 * Copyright (C) 2002-2003 Ian Willis. All rights reserved.                   *
 *                                                                            *
 * This script is free to use for non-commercial individual use.              *
 *                                                                            *
 * Use of this script by companies or on commercial web sites requires a      *
 * commercial license. For commercial licence details, please visit:          *
 *     http://www.digvid.info/isearch/commercial.php                          *
 *                                                                            *
 ******************************************************************************/


/* Clear the iSearch search log file */
function isearch_clearSearchLog()
{
    global $isearch_table_info;

    mysql_query("UPDATE $isearch_table_info SET search_log=''");
}


/* Return the contents of the spider log */
function isearch_getSearchLog()
{
    global $isearch_table_info;

    $search_log = "";

    $resultInfo = mysql_query ("SELECT search_log FROM $isearch_table_info");
    if ($resultInfo)
    {
        $isearch_itemInfo = mysql_fetch_object($resultInfo);
        if ($isearch_itemInfo)
        {
            $search_log = $isearch_itemInfo->search_log;
        }
    }

    return $search_log;
}


/* Save the string in the iSearch log file */
function isearch_searchLog($string)
{
    global $isearch_table_info;
    global $isearch_adminEmail;
    global $isearch_searchLogEmailDays;
    global $isearch_searchLogLastEmailed;

    $search_log = isearch_getSearchLog() . date("M d, Y, H:i:s - ") . $string . "\n";

    mysql_query("UPDATE $isearch_table_info SET search_log='$search_log'");

    if ($isearch_searchLogEmailDays > 0)
    {
        $now = time();
        if ($isearch_searchLogLastEmailed + ($isearch_searchLogEmailDays * 60 * 60 * 24) < $now)
        {
            /* Email the search log */
            $mailTo = "$isearch_adminEmail";
            $mailSubject = "iSearch search log";
            $mailBody = "The following searches have been performed on your site:\n";
            $mailBody .= "\n";
            $mailBody .= isearch_getSearchLog();
            $mailBody .= "\n";
            $mailBody .= "This email is automatically generated by iSearch. To change how often\n";
            $mailBody .= "this email is sent, please use your iSearch admin control panel.\n";
            $mailBody .= "\n";
            $mailBody .= "Visit the iSearch home page at http://www.digvid.info/isearch/home.php\n";
            $mailHeaders = "From: $isearch_adminEmail\n";
            if (mail($mailTo, $mailSubject, $mailBody, $mailHeaders))
            {
                mysql_query("UPDATE $isearch_table_info SET search_log_last_emailed='$now'");
                $isearch_searchLogLastEmailed = $now;
                isearch_clearSearchLog();
            }
        }
    }
}


/* Clean the search string */
function isearch_cleanSearchString($data)
{
    $data = utf8_decode($data);

    /* Convert to lower case, doing accented character conversion correctly */
    $data = strtr($data, "ABCDEFGHIJKLMNOPQRSTUVWXYZ" . chr(0x8a) . chr(0x8e) ,
                         "abcdefghijklmnopqrstuvwxyz" . chr(0x9a) . chr(0x9e) );

    /* Strip out all characters except numeric, alpha, whitespace, quote or bracket */
    $data = preg_replace('/([^0-9a-z-' . chr(0x9a) . chr(0x9e) . '\s\)\(])/e', "", $data);

    /* Ensure that quotes and brackets are surrounded by spaces */
    $data = ereg_replace('"', ' " ', $data);
    $data = ereg_replace("\\(", ' ( ', $data);
    $data = ereg_replace("\\)", ' ) ', $data);

    /* Compact all white space into a single space character */
    $data = ereg_replace("[[:space:]]+", " ", $data);

    /* Strip white space from beginning and end of the string */
    $data = trim($data);

    /* Remove any "AND" and "OR" at beginning or end of search string */
    $data = ereg_replace("(^and |^or | and$| or$)", "", $data);

    /* Replace repeated AND, OR or NOT words */
    $data = ereg_replace(" and (and |or )+", " and ", $data);
    $data = ereg_replace(" or (and |or )+", " or ", $data);
    $data = ereg_replace(" not not ", " ", $data);

    $words = explode(" ", $data);
    $data = "";

    $inQuote = False;
    $expectWord = True;
    $bracketCount = 0;
    for ($i = 0; $i < count($words); $i++)
    {
        if ($inQuote)
        {
            if ($words[$i] == '"')
            {
                $inQuote = False;
                $expectWord = False;
                $data .= ' "';
            }
            else
            {
                $data .= " $words[$i]";
            }
        }
        else
        {
            switch ($words[$i])
            {
                case '"':
                    $inQuote = True;
                    if (!$expectWord)
                    {
                        $data .= ' AND';
                    }
                    $data .= ' "';
                    break;

                case '(':
                    if (!$expectWord)
                    {
                        $data .= ' AND';
                    }
                    $data .= ' (';
                    $bracketCount ++;
                    $expectWord = True;
                    break;

                case ')':
                    if (($bracketCount > 0) && ($expectWord))
                    {
                        $data .= ' )';
                        $bracketCount --;
                    }
                    $expectWord = False;
                    break;

                case "and":
                case "or":
                    if (!$expectWord)
                    {
                        $data .= " " . strtoupper($words[$i]);
                        $expectWord = True;
                    }
                    break;

                case "not":
                    if (!$expectWord)
                    {
                        $data .= " AND";
                        $expectWord = True;
                    }
                    $data .= " NOT";
                    break;

                default:
                    if (!$expectWord)
                    {
                        /* No operator between this word and the previos one.
                         * Insert an AND
                         */
                        $data .= " AND";
                    }
                    $data .= " $words[$i]";
                    $expectWord = False;
                    break;
            }
        }
    }

    if ($inQuote)
    {
        /* Incorrect number of quotes - add a final closing quote */
        $data .= ' "';
    }

    while ($bracketCount > 0)
    {
        $data .= ' )';
        $bracketCount --;
    }

    /* Strip white space from the beginning and end of the string */
    $data = trim($data);

    return $data;
}


/* Add a URL to the array of search results. Only add the URL if $addIfNotThere
 * is set to True.
 */
function isearch_addResult($url, $title, $description, $size, $ranking = 1, $addIfNotThere = False)
{
    global $isearch_resultArray;

    /* Check whether URL is already in result array */
    $found = False;
    if (isset($isearch_resultArray))
    {
        for ($i = 0; $i < count($isearch_resultArray); $i++)
        {
            if ($isearch_resultArray[$i]['url'] == $url)
            {
                $found = True;
                $isearch_resultArray[$i]['ranking'] += $ranking;
                break;
            }
        }
    }

    if ((!$found) && ($addIfNotThere))
    {
        /* Result was not found - Add to array */
        $isearch_resultArray[] = array(
                                'url' => $url,
                                'title' => $title,
                                'description' => $description,
                                'size' => $size,
                                'ranking' => $ranking );
    }
}


/* Sort the results array, based on ranking order */
function isearch_sortResults()
{
    global $isearch_resultArray;

    if (isset($isearch_resultArray))
    {
        $finished = False;

        while (! $finished)
        {
            $finished = True;
            for ($i = 1; $i < count($isearch_resultArray); $i++)
            {
                if ($isearch_resultArray[$i-1]['ranking'] < $isearch_resultArray[$i]['ranking'])
                {
                    /* Swap these 2 results. */
                    $temp = $isearch_resultArray[$i-1];
                    $isearch_resultArray[$i-1] = $isearch_resultArray[$i];
                    $isearch_resultArray[$i] = $temp;
                    $finished = False;
                }
            }
        }
    }
}


/* Search the site for a string */
function isearch_find($searchString)
{
    global $isearch_searchString;
    global $isearch_table_urls;
    global $isearch_resultArray;

    $isearch_searchString = $searchString;

    /* Build the query string */
    $query = "SELECT * FROM $isearch_table_urls WHERE";
    $not = "";

    $words = explode(" ", $isearch_searchString);
    for ($i = 0; $words[$i] != ""; $i++)
    {
        if (($words[$i] == "AND") || ($words[$i] == "OR"))
        {
            $query .= " " . $words[$i];
        }
        else if ($words[$i] == ")")
        {
            $query .= " )";
            $not = "";
        }
        else if ($words[$i] == "(")
        {
            $query .= " $not(";
            $not = "";
        }
        else if ($words[$i] == "NOT")
        {
            $not = "NOT ";
        }
        else
        {
            $query .= " _words_ " . $not . "REGEXP ";
            if ($words[$i] == '"')
            {
                $i++;
                $exp = "";
                while (($words[$i] != "") && ($words[$i] != '"'))
                {
                    $exp .= $words[$i] . " ";
                    $searchwords[] = $words[$i];
                    $i++;
                }
                $query .= '"' . trim($exp) . '"';
            }
            else
            {
                $query .= '"' . $words[$i] . '"';
                $searchwords[] = $words[$i];
            }
            $not = "";
        }
    }

    /* Perform 3 searches. The first one searches through all words on the page,
     * including keywords, to produce a list of pages that match. The next 2
     * searches may allow pages that should not match (e.g. if the search term
     * is "lion AND NOT tiger" and "lion" appears in the keywords, "tiger" does
     * not appear in the keywords, but does in the page body).
     */
    $resultWords = mysql_query(ereg_replace(" _words_ ", " words ", $query));
    $resultKeyWords = mysql_query(ereg_replace(" _words_ ", " keywords ", $query));
    $resultBigWords = mysql_query(ereg_replace(" _words_ ", " bigwords ", $query));

    /* Clear the result array */
    unset($isearch_resultArray);

    if ($resultWords)
    {
        $wordScore = 1;
        while ($item = mysql_fetch_object($resultWords))
        {
            $temp = explode("#", $item->words);
            $body = $temp[0];

            $count = -$wordScore;
            foreach ($searchwords as $word)
            {
                $pos = -1;
                do
                {
                    $pos ++;
                    $count += $wordScore;
                    $pos = strpos($body, $words[0], $pos);
                } while ($pos > 0);
                isearch_addResult($item->url, $item->title, $item->description, $item->size, $count, True);
            }
        }
    }

    if ($resultKeyWords)
    {
        $wordScore = 10;
        while ($item = mysql_fetch_object($resultKeyWords))
        {
            $body = $item->keywords;

            $count = -$wordScore;
            foreach ($searchwords as $word)
            {
                $pos = -1;
                do
                {
                    $pos ++;
                    $count += $wordScore;
                    $pos = strpos($body, $words[0], $pos);
                } while ($pos > 0);

                /* If result is not already present, do not add it. */
                isearch_addResult($item->url, $item->title, $item->description, $item->size, $count, False);
            }
        }
    }

    if ($resultBigWords)
    {
        $wordScore = 3;
        while ($item = mysql_fetch_object($resultBigWords))
        {
            $body = $item->bigwords;

            $count = -$wordScore;
            foreach ($searchwords as $word)
            {
                $pos = -1;
                do
                {
                    $pos ++;
                    $count += $wordScore;
                    $pos = strpos($body, $words[0], $pos);
                } while ($pos > 0);

                /* If result is not already present, do not add it. */
                isearch_addResult($item->url, $item->title, $item->description, $item->size, $count, False);
            }
        }
    }

    /* Sort the result array */
    isearch_sortResults();

    isearch_searchLog("$isearch_searchString");
}



function isearch_getHighlightWords($searchString)
{
    $temp = explode(" ", $searchString);

    $inQuote = False;
    $not = False;
    for ($i = 0; $i < count($temp); $i++)
    {
        if ($inQuote)
        {
            if ($temp[$i] == '"')
            {
                $inQuote = False;
            }
            else
            {
                $highlightWords[] = $temp[$i];
            }
        }
        else
        {
            if ($temp[$i] == '"')
            {
                $inQuote = True;
            }
            else if ($temp[$i] == "NOT")
            {
                $not = !($not);
            }
            else if (($temp[$i] != "AND") && ($temp[$i] != "OR") && ($temp[$i] != ")") && ($temp[$i] != "("))
            {
                $highlightWords[] = $temp[$i];
            }
        }
    }

    return $highlightWords;
}


function isearch_googleStyleDescription($resultIndex, $highlightWords)
{
    global $isearch_resultArray;
    global $isearch_table_urls;

    $isearch_googleMinBefore = 5;
    $isearch_googleMinAfter = 10;
    $isearch_googleMaxWordCount = 32;

    $item = $isearch_resultArray[$resultIndex];

    $url = $item['url'];
    $result = mysql_query ("SELECT words FROM $isearch_table_urls WHERE url='$url'");
    if (($result) && ($resultItem = mysql_fetch_object($result)))
    {
        $words = explode(" ", $resultItem->words);
    }
    else
    {
        /* Query failed */
        return $item['description'];
    }

    if (count($highlightWords) == 0)
    {
        return $item['description'];
    }

    /* Find the position of each word to highlight */
    for ($j = 0; $j < count($words); $j++)
    {
        for ($i = 0; $i < count($highlightWords); $i++)
        {
            if (eregi($highlightWords[$i], $words[$j]))
            {
                $pos[] = $j;
                break;  /* Avoid multiple entries in pos[] on same word */
            }
        }
    }

    if (count($pos) == 0)
    {
        /* This should never happen ! */
        $pos[] = 0;
        $isearch_googleMinAfter = 999;
    }
    else if (count($pos) == 1)
    {
        /* Increase the number of words displayed before and after the hit word */
        $isearch_googleMinBefore *= 2;
        $isearch_googleMinAfter = 999;
    }

    $trans = get_html_translation_table(HTML_ENTITIES);

    $wordCount = 0;
    $posCount = 0;
    $description = "";

    while (($wordCount < $isearch_googleMaxWordCount) && ($posCount < count($pos)))
    {
        $startPos = $pos[$posCount] - $isearch_googleMinBefore;
        if ($startPos < 0)
        {
            $startPos = 0;
        }
        $endPos = $pos[$posCount] + $isearch_googleMinAfter + 1;

        if (($posCount == 0) && ($startPos != 0))
        {
            $description = "... ";
        }
        for ($i = $startPos; $i < $endPos; $i++)
        {
            $wordCount ++;
            if ($wordCount > $isearch_googleMaxWordCount)
            {
                break;
            }
            $lastWord = $i;

            /* Check whether this is a matched word */
            if (($posCount < count($pos)) && ($i == $pos[$posCount]))
            {
                $description .= "<FONT class=\"isearch_highlight\">" . strtr($words[$i], $trans) . "</FONT> ";
                $posCount ++;

                if ($i + $isearch_googleMinAfter + 1 > $endPos)
                {
                    $endPos = $i + $isearch_googleMinAfter + 1;
                }
            }
            else
            {
                $description .= strtr($words[$i], $trans) . " ";
            }

            if (($posCount+1 < count($pos)) && ($i + $isearch_googleMinBefore >= $pos[$posCount+1]))
            {
                if ($pos[$posCount + 1] > $endPos)
                {
                    $endPos = $pos[$posCount + 1];
                }
            }
        }

        $description .= "... ";
    }

    if ($wordCount < $isearch_googleMaxWordCount)
    {
        $i = $lastWord + 1;
        while (($wordCount < $isearch_googleMaxWordCount) && ($i < count($words)))
        {
            $wordCount ++;
            $description .= $words[$i] . " ";
            $i++;
        }

        $description .= "... ";
    }

    return $description;
}


function isearch_highlight($in, $highlightWords)
{
    $words = explode(" ", $in);

    /* Search each word, and highlight  */
    for ($j = 0; $j < count($words); $j++)
    {
        for ($i = 0; $i < count($highlightWords); $i++)
        {
            if (eregi($highlightWords[$i], $words[$j]))
            {
                $words[$j] = "<FONT class=\"isearch_highlight\">" . $words[$j] . "</FONT>";
                break;
            }
        }
    }

    return implode(" ", $words);
}


/* Show results of a site search */
function isearch_showResults($pageNumber = 1)
{
    global $isearch_searchString;
    global $isearch_resultArray;
    global $isearch_resultsPerPage;
    global $isearch_googleStyleResults;
    global $isearch_targetFrame;
    global $isearch_keepCache;
    global $isearch_lang;
    global $isearch_version;

    $resultCount = count($isearch_resultArray);

    $maxPage = ceil($resultCount / $isearch_resultsPerPage);

    if ($pageNumber < 1)
    {
        $pageNumber = 1;
    }

    if ($pageNumber > $maxPage)
    {
        $pageNumber = $maxPage;
    }

    $lastResult = $pageNumber * $isearch_resultsPerPage;
    $firstResult = $lastResult - $isearch_resultsPerPage + 1;
    if ($lastResult > $resultCount)
    {
        $lastResult = $resultCount;
    }
    if ($firstResult < 0)
    {
        $firstResult = 0;
    }

    $trans = get_html_translation_table(HTML_ENTITIES);
    $htmlSearchString = strtr($isearch_searchString, $trans);

    $patterns[] = "/(%s)/";
    $replacements[] = "<FONT class=\"isearch_search\">" . $htmlSearchString . "</FONT>";
    $patterns[] = "/(%f)/";
    $replacements[] = $firstResult;
    $patterns[] = "/(%l)/";
    $replacements[] = $lastResult;
    $patterns[] = "/(%t)/";
    $replacements[] = $resultCount;

    foreach (array_keys($isearch_lang) as $key)
    {
        $isearch_lang_converted[$key] = preg_replace($patterns, $replacements, $isearch_lang[$key]);
    }

    echo "<!-- Results generated by iSearch version $isearch_version -->\n";
    echo "<TABLE class=\"isearch_head\" WIDTH=\"100%\" BORDER=\"0\"><TR class=\"isearch_head\">\n";
    echo "<TD class=\"isearch_head\">" . $isearch_lang_converted['results_head2'] . "</TD>\n";
    echo "<TD class=\"isearch_head\" align=\"right\">" . $isearch_lang_converted['results_head3'] . "</TD>\n";
    echo "</TR></TABLE><BR>\n";

    $highlightWords = isearch_getHighlightWords($isearch_searchString);

    if ($resultCount > 0)
    {
        for ($i = $firstResult-1; $i < $lastResult; $i++)
        {
            $item = $isearch_resultArray[$i];

            $url = $item['url'];
            $title = $item['title'];

            /* Use google style results if explicitly set, or if there is no
             * description for this page
             */
            $description = $item['description'];
            if (($isearch_googleStyleResults) || ("$description" == ""))
            {
                $description = isearch_googleStyleDescription($i, $highlightWords);
            }
            else
            {
                /* Highlight searched words */
                $description = isearch_highlight($description, $highlightWords);
            }

            echo "<A class=\"isearch_title\" HREF=\"$url\" TARGET=\"$isearch_targetFrame\">" . $title . "</A><BR>\n";
            echo "<FONT class=\"isearch_description\">" . $description . "</FONT><BR>\n";
            echo "<A class=\"isearch_url\" HREF=\"$url\" TARGET=\"$isearch_targetFrame\">" . $url . "</A>";
            echo "<FONT class=\"isearch_size\">&nbsp;-&nbsp;" . ceil($item['size'] / 1024) . 'k';
            if ($isearch_keepCache)
            {
                echo "&nbsp;-&nbsp;";
            }
            echo "</FONT>";
            if ($isearch_keepCache)
            {
                echo "<A class=\"isearch_viewcache\" HREF=\"viewcache.php?url=" . urlencode($url) . "\">" . $isearch_lang_converted['cached'] . "</A>";
            }
            echo "<BR><BR>\n";
        }
        echo "<BR>\n";

        /* If more than one results page, display "previous" and/or "next" links */
        if ($maxPage > 1)
        {
            echo "<TABLE class=\"isearch_prevnext\" BORDER=0 WIDTH=\"100%\">\n";
            echo "<TR class=\"isearch_prevnext\">\n";
            if ($pageNumber > 1)
            {
                $prevPageNumber = $pageNumber - 1;
                echo "<TD class=\"isearch_prevnext\" width=\"10%\" align=\"left\"><DIV align=\"left\">&nbsp;&nbsp;<A class=\"isearch_prevnext\" HREF=\"index.php?action=search&s=" . urlencode($isearch_searchString) . "&page=$prevPageNumber\">" . $isearch_lang_converted['previous'] . "</A></DIV></TD>\n";
            }
            else
            {
                echo "<TD class=\"isearch_prevnext\" width=\"10%\" align=\"left\">&nbsp;</TD>\n";
            }

            echo "<TD class=\"isearch_prevnext\" width=\"80%\" align=\"center\"><CENTER>&nbsp;";
            for ($i = 1; $i <= $maxPage; $i++)
            {
                if ($i == $pageNumber)
                {
                    echo "$i&nbsp;";
                }
                else
                {
                    echo "<A class=\"isearch_prevnext\" HREF=\"index.php?action=search&s=" . urlencode($isearch_searchString) . "&page=$i\">$i</A>&nbsp;";
                }
            }
            echo "</CENTER></TD>";

            if ($pageNumber < $maxPage)
            {
                $nextPageNumber = $pageNumber + 1;
                echo "<TD class=\"isearch_prevnext\" width=\"10%\" align=\"right\"><DIV align=\"right\"><A class=\"isearch_prevnext\" HREF=\"index.php?action=search&s=" . urlencode($isearch_searchString) . "&page=$nextPageNumber\">" . $isearch_lang_converted['next'] . "</A>&nbsp;&nbsp;</DIV></TD>\n";
            }
            else
            {
                echo "<TD class=\"isearch_prevnext\" width=\"10%\" align=\"left\">&nbsp;</TD>\n";
            }
            echo "</TR>\n";
            echo "</TABLE>\n";
        }
        echo "<BR>\n";
    }
    else
    {
        echo "<H2 class=\"isearch_nomatch\">" . $isearch_lang_converted['nomatch'] . "</H2><BR><BR>\n";
    }

    /*************************************************************************
     * The following line must not be removed or commented out. Doing so     *
     * invalidates your license to use iSearch.                              *
     *************************************************************************/
    echo "<font size=2>Powered&nbsp;by&nbsp;<a href=\"http://www.digvid.info/isearch/home.php\" target=\"_blank\">iSearch</a></font><BR>\n";
}


/* Show the site map */
function isearch_showSiteMap($currentId = -1, $depth = 0)
{
    global $isearch_table_urls;
    global $isearch_targetFrame;

    if ($currentId == -1)
    {
        mysql_query ("LOCK TABLES $isearch_table_urls READ");
    }

    $result = mysql_query ("SELECT id, title, url FROM $isearch_table_urls WHERE referrer_id='$currentId'");
    if (($result) && (mysql_num_rows($result) > 0))
    {
        echo "<UL>\n";
        while ($item = mysql_fetch_object($result))
        {
            echo "<LI><A HREF=\"$item->url\" TARGET=\"$isearch_targetFrame\">$item->title</A><BR></LI>\n";
            if (($item->id > -1) && ($depth < 10))
            {
                isearch_showSiteMap($item->id, $depth+1);
            }
        }
        echo "</UL>\n";
    }

    if ($currentId == -1)
    {
        mysql_query ("UNLOCK TABLES");

        /*************************************************************************
         * The following line must not be removed or commented out. Doing so     *
         * invalidates your license to use iSearch.                              *
         *************************************************************************/
        echo "<font size=2>Powered&nbsp;by&nbsp;<a href=\"http://www.digvid.info/isearch/home.php\" target=\"_blank\">iSearch</a></font><BR>\n";
    }
}

?>
