<?php

/******************************************************************************
 * iSearch - website search engine                                            *
 *                                                                            *
 * Visit the iSearch homepage at http://www.digvid.info/isearch/home.php      *
 *                                                                            *
 * Copyright (C) 2002-2003 Ian Willis. All rights reserved.                   *
 *                                                                            *
 * This script is free to use for non-commercial individual use.              *
 *                                                                            *
 * Use of this script by companies or on commercial web sites requires a      *
 * commercial license. For commercial licence details, please visit:          *
 *     http://www.digvid.info/isearch/commercial.php                          *
 *                                                                            *
 ******************************************************************************/

/******************************************************************************
 *                   START OF LANGUAGE CONFIGURATION OPTIONS                  *
 *                                                                            *
 * Language       : English                                                   *
 * Contributed By : Ian Willis                                                *
 ******************************************************************************/

/* The language strings contained in this file are subjected to the following
 * translations before being displayed to the user:
 *  %s  The string that the user is searching for
 *  %f  The number of the first result to be displayed
 *  %l  The number of the last result to be displayed
 *  %t  The total number of results found
 */

/* The 2 letter language code used to identify this language. Please see
 *      http://www.w3.org/WAI/ER/IG/ert/iso639.htm
 * for a list of the 2 letter codes. This is used in the Content-Language
 * meta tag for the search results pages.
 */
$isearch_languageCode = "EN";


/* English :    "Search This Site"
 * Usage :      Search result page title and heading when accessed without
 *              search form results (i.e. when just displaying the search form.
 */
$isearch_lang['search_title'] = "Search This Site";

/* English :    "Site Search Results"
 * Usage :      Search result page title and top level heading
 */
$isearch_lang['results_title'] = "Site Search Results";

/* English :    "Cached Page"
 * Usage :      Title shown when displaying a page from cache
 */
$isearch_lang['viewcache_title'] = "Cached Page";

/* English :    "Search results for '%s'"
 * Usage :      Search result page second level heading
 */
$isearch_lang['results_head2'] = "Search results for '%s'";

/* English :    "Showing results "
 * Usage :      Used in results page, e.g.:
 *                  Showing results %f to %l of %t
 */
$isearch_lang['results_head3'] = "Showing results %f to %l of %t";

/* English :    "No matches found."
 * Usage :      Displayed on the results page when no search matches are found.
 */
$isearch_lang['nomatch'] = "No matches found.";

/* English :    "Cached"
 * Usage :      Displayed on the results page to indicate that a cached copy of
 *              the page has been kept.
 */
$isearch_lang['cached'] = "Cached";

/* English :    "&lt;&lt;&nbsp;Previous&nbsp;Page"
 * Usage :      Displays "<< Previous Page" at the bottom of the search results.
 */
$isearch_lang['previous'] = "&lt;&lt;&nbsp;Previous&nbsp;Page";

/* English :    "Next&nbsp;Page&nbsp;&gt;&gt;"
 * Usage :      Displays "Next Page >>" at the bottom of the search results.
 */
$isearch_lang['next'] = "Next&nbsp;Page&nbsp;&gt;&gt;";

/* English :    "This is the contents of the iSearch cache for the URL %u"
 * Usage :      Displayed when a page is being displayed from the iSearch cache.
 */
$isearch_lang['cachedpage'] = "This is the contents of the iSearch cache for the URL %u";

/* English :    "Search Site"
 * Usage :      Displayed on the search form button. When this button is clicked
 *              the search is performed.
 */
$isearch_lang['searchbutton'] = "Search Site";

/* English :    "Help"
 * Usage :      Displayed on the search form button. When this button is clicked
 *              the help page is displayed.
 */
$isearch_lang['helpbutton'] = "Help";

/******************************************************************************
 *                    END OF LANGUAGE CONFIGURATION OPTIONS                   *
 ******************************************************************************/
?>
